package com.steerinfo.baseinfo.meterbasetimesinfo.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasetimesinfo.model.MeterBaseTimesInfo;
import com.steerinfo.baseinfo.meterbasetimesinfo.service.IMeterBaseTimesInfoService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseTimesInfo RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-11 04:34
 * 类描述
 * 修订历史：
 * 日期：2020-06-11
 * 作者：generator
 * 参考：
 * 描述：MeterBaseTimesInfo RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasetimesinfos")
@Api(value = "/${api.version}/meterbasetimesinfos", tags = "物料计量时间段配置 - MeterBaseTimesInfoController")
public class MeterBaseTimesInfoController extends BaseRESTfulController {

    @Autowired
    IMeterBaseTimesInfoService meterBaseTimesInfoService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasetimesinfo:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseTimesInfo> list = meterBaseTimesInfoService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasetimesinfo:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseTimesInfo> list = meterBaseTimesInfoService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseTimesInfo对象创建")
    @ApiImplicitParam(name = "meterBaseTimesInfo", value = "详细实体meterBaseTimesInfo", required = true, dataType = "MeterBaseTimesInfo")
    //@RequiresPermissions("meterbasetimesinfo:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseTimesInfo model) {
        try {
            String msg = meterBaseTimesInfoService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasetimesinfo:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseTimesInfo meterBaseTimesInfo = meterBaseTimesInfoService.getById(id);
            return success(meterBaseTimesInfo);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseTimesInfo信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseTimesInfo", value = "详细实体meterBaseTimesInfo", required = true, dataType = "MeterBaseTimesInfo")
    })
    //@RequiresPermissions("meterbasetimesinfo:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseTimesInfo model) {
        try {
            String msg = meterBaseTimesInfoService.checkandupdate(id, model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasetimesinfo:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseTimesInfoService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "启用标识符", notes = "根据传过来的MeterBaseTimesInfo集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseTimesInfo", value = "详细实体MeterBaseTimesInfo", required = true, dataType = "MeterBaseTimesInfo")
    })
    @Transactional
    @PostMapping(value = "/Recovery")
    public RESTfulResult Recovery(@RequestBody List<MeterBaseTimesInfo> models) {
        try {
            String msg = meterBaseTimesInfoService.Recovery(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "废除标识符", notes = "根据传过来的MeterBaseTimesInfo集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseTimesInfo", value = "详细实体MeterBaseTimesInfo", required = true, dataType = "MeterBaseTimesInfo")
    })
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseTimesInfo> models) {
        try {
            String msg = meterBaseTimesInfoService.abolish(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }
}
